from flask import request, flash
from app.utils.priv_required import priv_required
from app.models.trophies import Trophy, Title
from app.forms.trophies import CreateTrophyForm
from app.utils.render import render
from app import app, db


@app.route('/admin/trophies', methods=['GET', 'POST'])
@priv_required('access-admin-panel', )
def adm_trophies():
    form = CreateTrophyForm()
    if request.method == "POST":
        if form.validate_on_submit():
            if form.is_title.data:
                trophy = Title(form.name.data, form.title.data)
                type = 'titre'
            else:
                trophy = Trophy(form.name.data)
                type = 'trophée'
            db.session.add(trophy)
            db.session.commit()
            flash(f'Nouveau {type} ajoutée', 'ok')
        else:
            flash('Erreur lors de la création du trophée', 'error')

    trophies = Trophy.query.all()
    return render('admin/trophies.html', trophies=trophies,
        form=form)
